const http = require("http");
const fs = require("fs");
const faker = require("faker");

const file = "data.txt";

const server = http.createServer(function (req, resp) {
  if (req.method === "POST") {
    console.log("writing data to stream.");
    const writeStream = fs.createWriteStream(file);
    for (let i = 0; i <= 1000; i++) {
      writeStream.write(faker.lorem.words(20) + "\n");
    }

    writeStream.end();
    resp.end();
  } else if (req.method === "GET") {
    console.log("reading data.");
    // getting data in a single chunk
    /* fs.readFile(file, (err, data) => {
      if (err) throw err;
      resp.end(data);
    }); */

    // doing data streaming
    var data = "";
    const readStream = fs.createReadStream(file);
    readStream.on("data", (chunk) => {
      console.log("chunk data received.");
      data += chunk;
    });
    // method will be called when no more data is available for read.
    readStream.on("end", () => {
      resp.end(data);
    });
  } else {
    throw new Error("NOT_YET_IMPLEMENTED");
  }
});

// start app
const PORT = process.env.PORT || 5001;
server.listen(PORT, () => {
  console.log(`Server started on port ${PORT}`);
});
